zoukankan      html  css  js  c++  java
  • poj 3186 Treats for the Cows(滚动DP OR 记忆化搜索)

    O - Treats for the Cows

     POJ - 3186 

    FJ has purchased N (1 <= N <= 2000) yummy treats for the cows who get money for giving vast amounts of milk. FJ sells one treat per day and wants to maximize the money he receives over a given period time. 

    The treats are interesting for many reasons:
    • The treats are numbered 1..N and stored sequentially in single file in a long box that is open at both ends. On any day, FJ can retrieve one treat from either end of his stash of treats.
    • Like fine wines and delicious cheeses, the treats improve with age and command greater prices.
    • The treats are not uniform: some are better and have higher intrinsic value. Treat i has value v(i) (1 <= v(i) <= 1000).
    • Cows pay more for treats that have aged longer: a cow will pay v(i)*a for a treat of age a.
    Given the values v(i) of each of the treats lined up in order of the index i in their box, what is the greatest value FJ can receive for them if he orders their sale optimally? 

    The first treat is sold on day 1 and has age a=1. Each subsequent day increases the age by 1.
    Input
    Line 1: A single integer, N 

    Lines 2..N+1: Line i+1 contains the value of treat v(i)
    Output
    Line 1: The maximum revenue FJ can achieve by selling the treats
    Sample Input
    5
    1
    3
    1
    5
    2
    Sample Output
    43
    Hint
    Explanation of the sample: 

    Five treats. On the first day FJ can sell either treat #1 (value 1) or treat #5 (value 2). 

    FJ sells the treats (values 1, 3, 1, 5, 2) in the following order of indices: 1, 5, 2, 3, 4, making 1x1 + 2x2 + 3x3 + 4x1 + 5x5 = 43.

    题目大意:给出的一系列的数字,可以看成一个双向队列,每次只能从队首或者队尾出队,第n个出队就拿这个数乘以n,最后将和加起来,求最大和


    状态:dp[i][j]表示第i次移出j位置所得到的最大值

    状态转移方程:dp[i][j] = max(dp[i-1][j-1]+arr[j]*i,dp[i-1][j]+arr[N-(i-j)+1]*i)

    除了背包外,第一次完全自己独立思考的一道DP题目;

    #include <iostream>
    #include <stdio.h>
    #include <cstring>
    using namespace std;
    #define MAXN 2005
    #define INF 0x3f3f3f3f
    
    int arr[MAXN];
    int dp[MAXN][MAXN];///dp[i][j]表示第i次移出j位置所得到的最大值
    
    int main(){
        int N;
        while(~scanf("%d",&N)){
            for(int i=1;i<=N;++i)
                scanf("%d",&arr[i]);
            memset(dp[1],0,sizeof(dp[1]));
            dp[1][1]=1*arr[1],dp[1][0]=1*arr[N];
            for(int i=2;i<=N;i++){  ///第i次移出
                //dp[i][j] = -INF ;
                for(int j=0;j<=i;j++){
                    if(j==0) dp[i][j] = dp[i-1][j]+arr[N-(i-j)+1]*i;
                    else if(j==i) dp[i][j] = dp[i-1][j-1]+arr[i]*i;
                    else dp[i][j] = max(dp[i-1][j-1]+arr[j]*i,dp[i-1][j]+arr[N-(i-j)+1]*i) ;
                }
            }
            int mmax=-INF;
            for(int i=0;i<N;i++)
                mmax=max(mmax,dp[N][i]);
            printf("%d
    ",mmax);
        }
        return 0;
    }
    

    自己闲的*疼尝试了一把滚动数组,突然下面的代码还是会蒙圈的。。。

    #include <iostream>
    #include <stdio.h>
    #include <cstring>
    using namespace std;
    #define MAXN 2005
    #define INF 0x3f3f3f3f
    
    int arr[MAXN];
    int dp[3][MAXN];///dp[i][j]表示第i次移出j位置所得到的最大值
    
    int main(){
        int N;
        while(~scanf("%d",&N)){
            for(int i=1;i<=N;++i)
                scanf("%d",&arr[i]);
            memset(dp[1],0,sizeof(dp[1]));
            dp[1][1]=1*arr[1],dp[1][0]=1*arr[N];
            int nw=1,old=2;
            for(int i=2,j;i<=N;i++){  ///第i次移出
                for(j=0,swap(nw,old);j<=i;j++){
                    if(j==0) dp[nw][j] = dp[old][j]+arr[N-(i-j)+1]*i;
                    else if(j==i) dp[nw][j] = dp[old][j-1]+arr[i]*i;
                    else dp[nw][j] = max(dp[old][j-1]+arr[j]*i,dp[old][j]+arr[N-(i-j)+1]*i) ;
                }
            }
            int mmax=-INF;
            int tmp = (N%2==0 ? 2 :1);
            for(int i=0;i<N;i++)
                mmax=max(mmax,dp[tmp][i]);
            printf("%d
    ",mmax);
        }
        return 0;
    }
    

    其实最简单的还是网上的

    由于每次要么从头取,要么从尾取,于是状态转移方程为:

    dp[i][j]=max(dp[i-1][j]+v[i]*(i+j),dp[i][j-1]+v[n-j+1]*(i+j));

    所以DP的题目还是在开始的时候状态的选取还是很重要的,这直接影响到了后来的状态转移方程的选取!!!谨记

    #include<stdio.h>
    #include<algorithm>
    
    using namespace std;
    
    int dp[2005][2005];
    int v[2005];
    
    int max(int a,int b)
    {
    	if(a>b)
    		return a;
    	else
    		return b;
    }
    
    int main()
    {
    	int i,j,n;
    	while(scanf("%d",&n)!=EOF)
    	{
    		for(i=1;i<=n;i++)
    			scanf("%d",&v[i]);
    		memset(dp,0,sizeof(dp));
    		for(i=0;i<=n;i++)
    			for(j=0;i+j<=n;j++)
    			{
    				if(i==0&&j==0)
    					dp[i][j]=0;
    				else if(i==0&&j!=0)
    					dp[i][j]=max(dp[i][j],dp[i][j-1]+v[n-j+1]*(i+j));
    				else if(i!=0&&j==0)
    					dp[i][j]=max(dp[i][j],dp[i-1][j]+v[i]*(i+j));
    				else
    					dp[i][j]=max(dp[i-1][j]+v[i]*(i+j),dp[i][j-1]+v[n-j+1]*(i+j));
    			}
    		int ans=0;
    		for(i=0;i<=n;i++)
    			if(dp[i][n-i]>ans)
    				ans=dp[i][n-i];
    		printf("%d/n",ans);
    	}
    	return 0;
    }
    




  • 相关阅读:
    Luogu P2181 对角线 简单数学,细节
    vscode 配置C、C++环境,编写运行C、C++(转)
    用家庭电脑架设minecraft服务器
    用阿里云架设我的世界(minecraft)服务器
    在线数独
    数学物理笔记
    复活的asdf1229
    test
    GitHub从小白到精通(第一章 初识)
    抛砖引玉,浅讲Handler和线程的关系
  • 原文地址:https://www.cnblogs.com/zswbky/p/6792909.html
Copyright © 2011-2022 走看看